/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 1244:  /* *p fetchadd_rel_di */
    case 1243:  /* *p fetchadd_rel_si */
    case 1242:  /* *p fetchadd_acq_di */
    case 1241:  /* *p fetchadd_acq_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1240:  /* *p xchg_acq_di */
    case 1239:  /* *p xchg_acq_si */
    case 1238:  /* *p xchg_acq_hi */
    case 1237:  /* *p xchg_acq_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 1236:  /* *p cmpxchg_rel_di */
    case 1235:  /* *p cmpxchg_acq_di */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1234:  /* *p cmpxchg_rel_si */
    case 1233:  /* *p cmpxchg_rel_hi */
    case 1232:  /* *p cmpxchg_rel_qi */
    case 1231:  /* *p cmpxchg_acq_si */
    case 1230:  /* *p cmpxchg_acq_hi */
    case 1229:  /* *p cmpxchg_acq_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 1228:  /* *p *memory_barrier */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 1217:  /* *p *fpcmp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1201:  /* *p *mux2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XEXP (pat, 0));
      ro[7] = *(ro_loc[7] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1195:  /* *p *mux1_brcst_v8qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 7);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 6);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 5);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 4);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 3);
      recog_data.dup_num[4] = 2;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 2);
      recog_data.dup_num[5] = 2;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0, 1);
      recog_data.dup_num[6] = 2;
      break;

    case 1167:  /* *p vec_widen_smult_odd_v4hi */
    case 1166:  /* *p vec_widen_smult_even_v4hi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1165:  /* *p pmpyshr2_u */
    case 1164:  /* *p pmpyshr2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1125:  /* *p *ptr_extend_plus_2 */
    case 1124:  /* *p ptr_extend_plus_imm */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1127:  /* *p probe_stack_address */
    case 1122:  /* *p builtin_setjmp_receiver */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1120:  /* *p prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1107:  /* *p gr_restore_internal */
    case 1106:  /* *p gr_spill_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1105:  /* *p *tablejump_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1118:  /* *p *trap */
    case 1104:  /* *p indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 1));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1103:  /* *p jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1121:  /* *p nonlocal_goto_receiver */
    case 1119:  /* *p break_f */
    case 1117:  /* *p pre_cycle */
    case 1116:  /* *p nop_x */
    case 1115:  /* *p nop_b */
    case 1114:  /* *p nop_f */
    case 1113:  /* *p nop_i */
    case 1112:  /* *p nop_m */
    case 1111:  /* *p nop */
    case 1102:  /* *p return */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1101:  /* *p return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1100:  /* *p sibcall_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1099:  /* *p call_value_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 3), 0));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1098:  /* *p call_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1097:  /* *p sibcall_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1096:  /* *p call_value_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1095:  /* *p call_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1092:  /* *p *bit_one */
    case 1091:  /* *p *bit_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1090:  /* *p *cmpxf_internal */
    case 1089:  /* *p *cmpdf_internal */
    case 1088:  /* *p *cmpsf_internal */
    case 1087:  /* *p *cmpdi_adjusted */
    case 1086:  /* *p *cmpdi_normal */
    case 1085:  /* *p *cmpsi_adjusted */
    case 1084:  /* *p *cmpsi_normal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1077:  /* *p shrp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1068:  /* *p *shladd_elim */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1062:  /* *p *fnmaxf_trunc_df */
    case 1061:  /* *p *fnmaxf_trunc_sf */
    case 1034:  /* *p *fnmadf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1059:  /* *p *fmsxf_trunc_df */
    case 1058:  /* *p *fmsxf_trunc_sf */
    case 1032:  /* *p *fmsdf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1056:  /* *p *fmaxf_trunc_df */
    case 1055:  /* *p *fmaxf_trunc_sf */
    case 1030:  /* *p *fmadf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1053:  /* *p *nmulxf3_truncdf */
    case 1052:  /* *p *nmulxf3_truncsf */
    case 1028:  /* *p *nmuldf3_trunc */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1214:  /* *p fnmav2sf4 */
    case 1060:  /* *p fnmaxf4 */
    case 1033:  /* *p fnmadf4 */
    case 1013:  /* *p fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1212:  /* *p fmsv2sf4 */
    case 1057:  /* *p fmsxf4 */
    case 1031:  /* *p fmsdf4 */
    case 1012:  /* *p fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1048:  /* *p *ncopysignxf3 */
    case 1024:  /* *p *ncopysigndf3 */
    case 1007:  /* *p *ncopysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1047:  /* *p copysignxf3 */
    case 1023:  /* *p copysigndf3 */
    case 1006:  /* *p copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1186:  /* *p vec_pack_ssat_v2si */
    case 1185:  /* *p vec_pack_usat_v4hi */
    case 1184:  /* *p vec_pack_ssat_v4hi */
    case 998:  /* *p *umulditi3_internal */
    case 997:  /* *p *mulditi3_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 996:  /* *p subti3 */
    case 995:  /* *p addti3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 990:  /* *p umuldi3_highpart */
    case 989:  /* *p smuldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 988:  /* *p *madddi4_elim */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[6] = *(ro_loc[6] = &XEXP (pat, 0));
      ro[7] = *(ro_loc[7] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 987:  /* *p madddi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1209:  /* *p *negabsv2sf2 */
    case 1046:  /* *p *nabsxf2 */
    case 1022:  /* *p *nabsdf2 */
    case 1005:  /* *p *nabssf2 */
    case 983:  /* *p *adddi3_plus1_alt */
    case 974:  /* *p *addsi3_plus1_alt */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1223:  /* *p fmix_lr */
    case 1222:  /* *p *vec_interleave_lowv2sf */
    case 1221:  /* *p *vec_interleave_highv2sf */
    case 1220:  /* *p fswap */
    case 1213:  /* *p *fpnmpy */
    case 1204:  /* *p *vec_interleave_highv2si */
    case 1203:  /* *p *vec_interleave_lowv2si */
    case 1200:  /* *p mix2_odd */
    case 1199:  /* *p mix2_even */
    case 1198:  /* *p *vec_interleave_highv4hi */
    case 1197:  /* *p *vec_interleave_lowv4hi */
    case 1190:  /* *p *mix1_odd */
    case 1189:  /* *p *mix1_even */
    case 1188:  /* *p *vec_interleave_highv8qi */
    case 1187:  /* *p *vec_interleave_lowv8qi */
    case 1051:  /* *p *nmulxf3 */
    case 1043:  /* *p *mulxf3_truncdf */
    case 1042:  /* *p *mulxf3_truncsf */
    case 1040:  /* *p *subxf3_truncdf */
    case 1039:  /* *p *subxf3_truncsf */
    case 1037:  /* *p *addxf3_truncdf */
    case 1036:  /* *p *addxf3_truncsf */
    case 1027:  /* *p *nmuldf3 */
    case 1019:  /* *p *muldf3_trunc */
    case 1017:  /* *p *subdf3_trunc */
    case 1015:  /* *p *adddf3_trunc */
    case 1010:  /* *p *nmulsf3 */
    case 982:  /* *p *adddi3_plus1 */
    case 973:  /* *p *addsi3_plus1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 970:  /* *p *tbit_or_3 */
    case 969:  /* *p *tbit_or_2 */
    case 958:  /* *p *tbit_and_3 */
    case 957:  /* *p *tbit_and_2 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 968:  /* *p *tbit_or_1 */
    case 967:  /* *p *tbit_or_0 */
    case 956:  /* *p *tbit_and_1 */
    case 955:  /* *p *tbit_and_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 966:  /* *p *cmpdi_orcm_1 */
    case 962:  /* *p *cmpsi_orcm_1 */
    case 954:  /* *p *cmpdi_andnot_1 */
    case 950:  /* *p *cmpsi_andnot_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 965:  /* *p *cmpdi_orcm_0 */
    case 961:  /* *p *cmpsi_orcm_0 */
    case 953:  /* *p *cmpdi_andnot_0 */
    case 949:  /* *p *cmpsi_andnot_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 964:  /* *p *cmpdi_or_1 */
    case 960:  /* *p *cmpsi_or_1 */
    case 952:  /* *p *cmpdi_and_1 */
    case 948:  /* *p *cmpsi_and_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 963:  /* *p *cmpdi_or_0 */
    case 959:  /* *p *cmpsi_or_0 */
    case 951:  /* *p *cmpdi_and_0 */
    case 947:  /* *p *cmpsi_and_0 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 0));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1252:  /* *p fixuns_truncrfdi2_alts */
    case 1251:  /* *p fix_truncrfdi2_alts */
    case 999:  /* *p negti2 */
    case 946:  /* *p one_cmplbi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1219:  /* *p fpack */
    case 1216:  /* *p sminv2sf3 */
    case 1215:  /* *p smaxv2sf3 */
    case 1210:  /* *p mulv2sf3 */
    case 1205:  /* *p *vecinit_v2si */
    case 1183:  /* *p *cmpgt_v2si */
    case 1182:  /* *p *cmpgt_v4hi */
    case 1181:  /* *p *cmpgt_v8qi */
    case 1180:  /* *p *cmpeq_v2si */
    case 1179:  /* *p *cmpeq_v4hi */
    case 1178:  /* *p *cmpeq_v8qi */
    case 1177:  /* *p lshrv2si3 */
    case 1176:  /* *p lshrv4hi3 */
    case 1175:  /* *p ashrv2si3 */
    case 1174:  /* *p ashrv4hi3 */
    case 1173:  /* *p ashlv2si3 */
    case 1172:  /* *p ashlv4hi3 */
    case 1171:  /* *p *sminv4hi3 */
    case 1170:  /* *p *uminv8qi3 */
    case 1169:  /* *p *smaxv4hi3 */
    case 1168:  /* *p *umaxv8qi3 */
    case 1163:  /* *p mulv4hi3 */
    case 1162:  /* *p *ussubv4hi3 */
    case 1161:  /* *p *ussubv8qi3 */
    case 1160:  /* *p *sssubv4hi3 */
    case 1159:  /* *p *sssubv8qi3 */
    case 1158:  /* *p subv2si3 */
    case 1157:  /* *p subv4hi3 */
    case 1156:  /* *p subv8qi3 */
    case 1155:  /* *p *usaddv4hi3 */
    case 1154:  /* *p *usaddv8qi3 */
    case 1153:  /* *p *ssaddv4hi3 */
    case 1152:  /* *p *ssaddv8qi3 */
    case 1151:  /* *p addv2si3 */
    case 1150:  /* *p addv4hi3 */
    case 1149:  /* *p addv8qi3 */
    case 1145:  /* *p xorv2si3 */
    case 1144:  /* *p xorv4hi3 */
    case 1143:  /* *p xorv8qi3 */
    case 1142:  /* *p iorv2si3 */
    case 1141:  /* *p iorv4hi3 */
    case 1140:  /* *p iorv8qi3 */
    case 1136:  /* *p andv2si3 */
    case 1135:  /* *p andv4hi3 */
    case 1134:  /* *p andv8qi3 */
    case 1082:  /* *p xordi3 */
    case 1081:  /* *p iordi3 */
    case 1079:  /* *p anddi3 */
    case 1076:  /* *p *rotlti3_internal */
    case 1075:  /* *p *lshrti3_internal */
    case 1074:  /* *p *ashrti3_internal */
    case 1073:  /* *p *ashlti3_internal */
    case 1072:  /* *p *rotldi3_internal */
    case 1071:  /* *p *rotrdi3_internal */
    case 1070:  /* *p lshrdi3 */
    case 1069:  /* *p ashrdi3 */
    case 1066:  /* *p ashldi3 */
    case 1065:  /* *p *rotlsi3_internal */
    case 1064:  /* *p *rotrsi3_internal */
    case 1063:  /* *p *ashlsi3_internal */
    case 1050:  /* *p smaxxf3 */
    case 1049:  /* *p sminxf3 */
    case 1041:  /* *p mulxf3 */
    case 1038:  /* *p subxf3 */
    case 1035:  /* *p addxf3 */
    case 1026:  /* *p smaxdf3 */
    case 1025:  /* *p smindf3 */
    case 1018:  /* *p muldf3 */
    case 1016:  /* *p subdf3 */
    case 1014:  /* *p adddf3 */
    case 1009:  /* *p smaxsf3 */
    case 1008:  /* *p sminsf3 */
    case 1002:  /* *p mulsf3 */
    case 1001:  /* *p subsf3 */
    case 1000:  /* *p addsf3 */
    case 986:  /* *p muldi3 */
    case 984:  /* *p subdi3 */
    case 981:  /* *p adddi3 */
    case 978:  /* *p mulsi3 */
    case 976:  /* *p subsi3 */
    case 972:  /* *p addsi3 */
    case 971:  /* *p mulhi3 */
    case 944:  /* *p iorbi3 */
    case 942:  /* *p andbi3 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 941:  /* *p *mix4right_3op */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 940:  /* *p mix4right */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 939:  /* *p *mix4left */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 938:  /* *p shift_mix4left */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1067:  /* *p *shladd */
    case 979:  /* *p maddsi4 */
    case 975:  /* *p *addsi3_shladd */
    case 937:  /* *p *depz_internal */
    case 936:  /* *p *shladdp4_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 935:  /* *p *insv_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1218:  /* *p *fselect */
    case 1211:  /* *p fmav2sf4 */
    case 1054:  /* *p fmaxf4 */
    case 1029:  /* *p fmadf4 */
    case 1011:  /* *p fmasf4 */
    case 934:  /* *p extzv */
    case 933:  /* *p extv */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (pat, 0));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 901:  /* *p *add_tprel22 */
    case 900:  /* *p *add_tprel14 */
    case 899:  /* *p *load_ltoff_tprel */
    case 895:  /* *p *add_dtprel22 */
    case 894:  /* *p *add_dtprel14 */
    case 893:  /* *p *load_ltoff_dtprel */
    case 889:  /* *p *load_ltoff_dtpmod */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1139:  /* *p *andnotv2si */
    case 1138:  /* *p *andnotv4hi */
    case 1137:  /* *p *andnotv8qi */
    case 1080:  /* *p *andnot */
    case 985:  /* *p *subdi3_minus1 */
    case 977:  /* *p *subsi3_minus1 */
    case 945:  /* *p *iorcmbi3 */
    case 943:  /* *p *andcmbi3 */
    case 887:  /* *p *load_symptr_low */
    case 886:  /* *p *load_symptr_high */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1126:  /* *p ip_value */
    case 1110:  /* *p bsp_value */
    case 885:  /* *p *movdi_ret_addr */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1250:  /* *p truncrfxf2 */
    case 1249:  /* *p truncrfdf2 */
    case 1248:  /* *p truncrfsf2 */
    case 1247:  /* *p extendxfrf2 */
    case 1246:  /* *p extenddfrf2 */
    case 1245:  /* *p extendsfrf2 */
    case 1208:  /* *p negv2sf2 */
    case 1207:  /* *p absv2sf2 */
    case 1202:  /* *p *mux2_brcst_hi */
    case 1196:  /* *p mux1_brcst_qi */
    case 1194:  /* *p *mux1_alt */
    case 1193:  /* *p *mux1_shuf */
    case 1192:  /* *p *mux1_mix */
    case 1191:  /* *p *mux1_rev */
    case 1148:  /* *p negv2si2 */
    case 1147:  /* *p negv4hi2 */
    case 1146:  /* *p negv8qi2 */
    case 1133:  /* *p one_cmplv2si2 */
    case 1132:  /* *p one_cmplv4hi2 */
    case 1131:  /* *p one_cmplv8qi2 */
    case 1094:  /* *p *seq_internal */
    case 1093:  /* *p *sne_internal */
    case 1083:  /* *p one_cmpldi2 */
    case 1078:  /* *p one_cmplsi2 */
    case 1045:  /* *p negxf2 */
    case 1044:  /* *p absxf2 */
    case 1021:  /* *p negdf2 */
    case 1020:  /* *p absdf2 */
    case 1004:  /* *p negsf2 */
    case 1003:  /* *p abssf2 */
    case 993:  /* *p bswapdi2 */
    case 992:  /* *p popcountdi2 */
    case 991:  /* *p negdi2 */
    case 980:  /* *p negsi2 */
    case 932:  /* *p fixuns_truncrfdi2 */
    case 931:  /* *p fixuns_truncxfdi2 */
    case 930:  /* *p fixuns_truncdfdi2 */
    case 929:  /* *p fixuns_truncsfdi2 */
    case 928:  /* *p floatunsdirf2 */
    case 927:  /* *p floatunsdixf2 */
    case 926:  /* *p floatunsdidf2 */
    case 925:  /* *p floatunsdisf2 */
    case 924:  /* *p fix_truncrfdi2 */
    case 923:  /* *p fix_truncxfdi2 */
    case 922:  /* *p fix_truncdfdi2 */
    case 921:  /* *p fix_truncsfdi2 */
    case 920:  /* *p floatdixf2 */
    case 919:  /* *p floatdirf2 */
    case 918:  /* *p truncxfdf2 */
    case 917:  /* *p truncxfsf2 */
    case 916:  /* *p truncdfsf2 */
    case 915:  /* *p extenddfxf2 */
    case 914:  /* *p extendsfxf2 */
    case 913:  /* *p extendsfdf2 */
    case 912:  /* *p zero_extendsidi2 */
    case 911:  /* *p zero_extendhidi2 */
    case 910:  /* *p zero_extendqidi2 */
    case 909:  /* *p extendsidi2 */
    case 908:  /* *p extendhidi2 */
    case 907:  /* *p extendqidi2 */
    case 884:  /* *p *gprel64_offset */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 883:  /* *p load_gprel */
    case 882:  /* *p *load_fptr_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 881:  /* *p speculation_check_ti */
    case 880:  /* *p speculation_check_xf */
    case 879:  /* *p speculation_check_df */
    case 878:  /* *p speculation_check_sf */
    case 877:  /* *p speculation_check_di */
    case 876:  /* *p speculation_check_si */
    case 875:  /* *p speculation_check_hi */
    case 874:  /* *p speculation_check_qi */
    case 873:  /* *p speculation_check_bi */
    case 872:  /* *p advanced_load_check_nc_ti */
    case 871:  /* *p advanced_load_check_nc_xf */
    case 870:  /* *p advanced_load_check_nc_df */
    case 869:  /* *p advanced_load_check_nc_sf */
    case 868:  /* *p advanced_load_check_nc_di */
    case 867:  /* *p advanced_load_check_nc_si */
    case 866:  /* *p advanced_load_check_nc_hi */
    case 865:  /* *p advanced_load_check_nc_qi */
    case 864:  /* *p advanced_load_check_nc_bi */
    case 863:  /* *p advanced_load_check_clr_ti */
    case 862:  /* *p advanced_load_check_clr_xf */
    case 861:  /* *p advanced_load_check_clr_df */
    case 860:  /* *p advanced_load_check_clr_sf */
    case 859:  /* *p advanced_load_check_clr_di */
    case 858:  /* *p advanced_load_check_clr_si */
    case 857:  /* *p advanced_load_check_clr_hi */
    case 856:  /* *p advanced_load_check_clr_qi */
    case 855:  /* *p advanced_load_check_clr_bi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 2), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 854:  /* *p zero_extendsidi2_nc */
    case 853:  /* *p zero_extendhidi2_nc */
    case 852:  /* *p zero_extendqidi2_nc */
    case 851:  /* *p zero_extendsidi2_clr */
    case 850:  /* *p zero_extendhidi2_clr */
    case 849:  /* *p zero_extendqidi2_clr */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0, 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 2);
      recog_data.dup_num[1] = 0;
      break;

    case 848:  /* *p movti_nc */
    case 847:  /* *p movxf_nc */
    case 846:  /* *p movdf_nc */
    case 845:  /* *p movsf_nc */
    case 844:  /* *p movdi_nc */
    case 843:  /* *p movsi_nc */
    case 842:  /* *p movhi_nc */
    case 841:  /* *p movqi_nc */
    case 840:  /* *p movbi_nc */
    case 839:  /* *p movti_clr */
    case 838:  /* *p movxf_clr */
    case 837:  /* *p movdf_clr */
    case 836:  /* *p movsf_clr */
    case 835:  /* *p movdi_clr */
    case 834:  /* *p movsi_clr */
    case 833:  /* *p movhi_clr */
    case 832:  /* *p movqi_clr */
    case 831:  /* *p movbi_clr */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0), 0, 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 2);
      recog_data.dup_num[1] = 0;
      break;

    case 830:  /* *p zero_extendsidi2_speculative_a */
    case 829:  /* *p zero_extendhidi2_speculative_a */
    case 828:  /* *p zero_extendqidi2_speculative_a */
    case 827:  /* *p zero_extendsidi2_speculative_advanced */
    case 826:  /* *p zero_extendhidi2_speculative_advanced */
    case 825:  /* *p zero_extendqidi2_speculative_advanced */
    case 806:  /* *p zero_extendsidi2_speculative */
    case 805:  /* *p zero_extendhidi2_speculative */
    case 804:  /* *p zero_extendqidi2_speculative */
    case 794:  /* *p zero_extendsidi2_advanced */
    case 793:  /* *p zero_extendhidi2_advanced */
    case 792:  /* *p zero_extendqidi2_advanced */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1253:  /* *p setf_exp_rf */
    case 1227:  /* *p *vec_extractv2sf_1_be */
    case 1226:  /* *p *vec_extractv2sf_1_le */
    case 1225:  /* *p *vec_extractv2sf_0_be */
    case 1224:  /* *p *vec_extractv2sf_0_le */
    case 1123:  /* *p ptr_extend */
    case 1109:  /* *p fr_restore */
    case 1108:  /* *p fr_spill */
    case 994:  /* *p *getf_exp_xf */
    case 898:  /* *p *load_tprel_ie */
    case 897:  /* *p *load_tprel22 */
    case 896:  /* *p *load_tprel64 */
    case 892:  /* *p *load_dtprel_gd */
    case 891:  /* *p *load_dtprel22 */
    case 890:  /* *p *load_dtprel64 */
    case 888:  /* *p load_dtpmod */
    case 824:  /* *p movti_speculative_a */
    case 823:  /* *p movxf_speculative_a */
    case 822:  /* *p movdf_speculative_a */
    case 821:  /* *p movsf_speculative_a */
    case 820:  /* *p movdi_speculative_a */
    case 819:  /* *p movsi_speculative_a */
    case 818:  /* *p movhi_speculative_a */
    case 817:  /* *p movqi_speculative_a */
    case 816:  /* *p movbi_speculative_a */
    case 815:  /* *p movti_speculative_advanced */
    case 814:  /* *p movxf_speculative_advanced */
    case 813:  /* *p movdf_speculative_advanced */
    case 812:  /* *p movsf_speculative_advanced */
    case 811:  /* *p movdi_speculative_advanced */
    case 810:  /* *p movsi_speculative_advanced */
    case 809:  /* *p movhi_speculative_advanced */
    case 808:  /* *p movqi_speculative_advanced */
    case 807:  /* *p movbi_speculative_advanced */
    case 803:  /* *p movti_speculative */
    case 802:  /* *p movxf_speculative */
    case 801:  /* *p movdf_speculative */
    case 800:  /* *p movsf_speculative */
    case 799:  /* *p movdi_speculative */
    case 798:  /* *p movsi_speculative */
    case 797:  /* *p movhi_speculative */
    case 796:  /* *p movqi_speculative */
    case 795:  /* *p movbi_speculative */
    case 791:  /* *p movti_advanced */
    case 790:  /* *p movxf_advanced */
    case 789:  /* *p movdf_advanced */
    case 788:  /* *p movsf_advanced */
    case 787:  /* *p movdi_advanced */
    case 786:  /* *p movsi_advanced */
    case 785:  /* *p movhi_advanced */
    case 784:  /* *p movqi_advanced */
    case 783:  /* *p movbi_advanced */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 1206:  /* *p *movv2sf_internal */
    case 1130:  /* *p *movv2si_internal */
    case 1129:  /* *p *movv4hi_internal */
    case 1128:  /* *p *movv8qi_internal */
    case 906:  /* *p *movrf_internal */
    case 905:  /* *p movxf_internal */
    case 904:  /* *p movdf_internal */
    case 903:  /* *p movsf_internal */
    case 902:  /* *p movti_internal */
    case 782:  /* *p movdi_internal */
    case 781:  /* *p movsi_internal */
    case 780:  /* *p movhi_internal */
    case 779:  /* *p movqi_internal */
    case 778:  /* *p movbi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 515:  /* sqrt_approx_rf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[0] = 1;
      break;

    case 514:  /* recip_approx_rf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 504:  /* m2subrf4_cond */
    case 503:  /* m2addrf4_cond */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 502:  /* m1subrf4_cond */
    case 501:  /* m1addrf4_cond */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[7] = *(ro_loc[7] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 500:  /* nmulrf3_cond */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 499:  /* mulrf3_cond */
    case 498:  /* subrf3_cond */
    case 497:  /* addrf3_cond */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 2));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 496:  /* fetchadd_rel_di */
    case 495:  /* fetchadd_rel_si */
    case 494:  /* fetchadd_acq_di */
    case 493:  /* fetchadd_acq_si */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 492:  /* xchg_acq_di */
    case 491:  /* xchg_acq_si */
    case 490:  /* xchg_acq_hi */
    case 489:  /* xchg_acq_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 488:  /* cmpxchg_rel_di */
    case 487:  /* cmpxchg_acq_di */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 486:  /* cmpxchg_rel_si */
    case 485:  /* cmpxchg_rel_hi */
    case 484:  /* cmpxchg_rel_qi */
    case 483:  /* cmpxchg_acq_si */
    case 482:  /* cmpxchg_acq_hi */
    case 481:  /* cmpxchg_acq_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 469:  /* *fpcmp */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 453:  /* *mux2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 3));
      break;

    case 447:  /* *mux1_brcst_v8qi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 7);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 6);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 5);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 4);
      recog_data.dup_num[3] = 2;
      recog_data.dup_loc[4] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 3);
      recog_data.dup_num[4] = 2;
      recog_data.dup_loc[5] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 2);
      recog_data.dup_num[5] = 2;
      recog_data.dup_loc[6] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1);
      recog_data.dup_num[6] = 2;
      break;

    case 419:  /* vec_widen_smult_odd_v4hi */
    case 418:  /* vec_widen_smult_even_v4hi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 417:  /* pmpyshr2_u */
    case 416:  /* pmpyshr2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 376:  /* *ptr_extend_plus_2 */
    case 375:  /* ptr_extend_plus_imm */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      break;

    case 480:  /* *memory_barrier */
    case 371:  /* pred_rel_mutex */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 368:  /* prefetch */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 366:  /* *conditional_trap */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 1));
      break;

    case 349:  /* gr_restore_internal */
    case 348:  /* gr_spill_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 347:  /* alloc */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 4), 0));
      break;

    case 378:  /* probe_stack_address */
    case 370:  /* builtin_setjmp_receiver */
    case 364:  /* insn_group_barrier */
    case 362:  /* bundle_selector */
    case 353:  /* set_bsp */
    case 346:  /* prologue_use */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 345:  /* epilogue_deallocate_stack_pr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0);
      recog_data.dup_num[0] = 3;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1);
      recog_data.dup_num[1] = 3;
      break;

    case 344:  /* epilogue_deallocate_stack */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[1] = 1;
      break;

    case 343:  /* prologue_allocate_stack_pr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 1), 1);
      recog_data.dup_num[0] = 5;
      break;

    case 342:  /* prologue_allocate_stack */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 1);
      recog_data.dup_num[0] = 3;
      break;

    case 341:  /* *tablejump_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 365:  /* *trap */
    case 340:  /* indirect_jump */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 339:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 338:  /* *return_false */
    case 337:  /* *return_true */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 373:  /* safe_across_calls_normal */
    case 372:  /* safe_across_calls_all */
    case 369:  /* nonlocal_goto_receiver */
    case 367:  /* break_f */
    case 363:  /* blockage */
    case 361:  /* pre_cycle */
    case 360:  /* nop_x */
    case 359:  /* nop_b */
    case 358:  /* nop_f */
    case 357:  /* nop_i */
    case 356:  /* nop_m */
    case 355:  /* nop */
    case 354:  /* flushrs */
    case 336:  /* return */
      break;

    case 335:  /* return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 334:  /* sibcall_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 333:  /* call_value_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 332:  /* call_gp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 3), 0));
      break;

    case 331:  /* sibcall_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      break;

    case 330:  /* call_value_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 329:  /* call_nogp */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 328:  /* *cond_opsi2_internal_b */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 1));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 327:  /* *cond_opsi2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (pat, 1));
      ro[6] = *(ro_loc[6] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 326:  /* *abssi2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 324:  /* *absdi2_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 325:  /* *cmovsi_internal */
    case 323:  /* *cmovdi_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 320:  /* doloop_end_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 0;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1), 0);
      recog_data.dup_num[2] = 0;
      recog_data.dup_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 2);
      recog_data.dup_num[3] = 0;
      break;

    case 319:  /* *br_false */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 318:  /* *br_true */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 317:  /* *bit_one */
    case 316:  /* *bit_zero */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 315:  /* *cmpxf_internal */
    case 314:  /* *cmpdf_internal */
    case 313:  /* *cmpsf_internal */
    case 312:  /* *cmpdi_adjusted */
    case 311:  /* *cmpdi_normal */
    case 310:  /* *cmpsi_adjusted */
    case 309:  /* *cmpsi_normal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 302:  /* shrp */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 293:  /* *shladd_elim */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 287:  /* *fnmaxf_trunc_df */
    case 286:  /* *fnmaxf_trunc_sf */
    case 259:  /* *fnmadf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 284:  /* *fmsxf_trunc_df */
    case 283:  /* *fmsxf_trunc_sf */
    case 257:  /* *fmsdf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 281:  /* *fmaxf_trunc_df */
    case 280:  /* *fmaxf_trunc_sf */
    case 255:  /* *fmadf_trunc_sf */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 278:  /* *nmulxf3_truncdf */
    case 277:  /* *nmulxf3_truncsf */
    case 253:  /* *nmuldf3_trunc */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 466:  /* fnmav2sf4 */
    case 285:  /* fnmaxf4 */
    case 258:  /* fnmadf4 */
    case 238:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 464:  /* fmsv2sf4 */
    case 282:  /* fmsxf4 */
    case 256:  /* fmsdf4 */
    case 237:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 273:  /* *ncopysignxf3 */
    case 249:  /* *ncopysigndf3 */
    case 232:  /* *ncopysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 379:  /* probe_stack_range */
    case 272:  /* copysignxf3 */
    case 248:  /* copysigndf3 */
    case 231:  /* copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 438:  /* vec_pack_ssat_v2si */
    case 437:  /* vec_pack_usat_v4hi */
    case 436:  /* vec_pack_ssat_v4hi */
    case 223:  /* *umulditi3_internal */
    case 222:  /* *mulditi3_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 221:  /* subti3 */
    case 220:  /* addti3 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 215:  /* umuldi3_highpart */
    case 214:  /* smuldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 213:  /* *madddi4_elim */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[5] = *(ro_loc[5] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 212:  /* madddi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 461:  /* *negabsv2sf2 */
    case 271:  /* *nabsxf2 */
    case 247:  /* *nabsdf2 */
    case 230:  /* *nabssf2 */
    case 208:  /* *adddi3_plus1_alt */
    case 199:  /* *addsi3_plus1_alt */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 475:  /* fmix_lr */
    case 474:  /* *vec_interleave_lowv2sf */
    case 473:  /* *vec_interleave_highv2sf */
    case 472:  /* fswap */
    case 465:  /* *fpnmpy */
    case 456:  /* *vec_interleave_highv2si */
    case 455:  /* *vec_interleave_lowv2si */
    case 452:  /* mix2_odd */
    case 451:  /* mix2_even */
    case 450:  /* *vec_interleave_highv4hi */
    case 449:  /* *vec_interleave_lowv4hi */
    case 442:  /* *mix1_odd */
    case 441:  /* *mix1_even */
    case 440:  /* *vec_interleave_highv8qi */
    case 439:  /* *vec_interleave_lowv8qi */
    case 276:  /* *nmulxf3 */
    case 268:  /* *mulxf3_truncdf */
    case 267:  /* *mulxf3_truncsf */
    case 265:  /* *subxf3_truncdf */
    case 264:  /* *subxf3_truncsf */
    case 262:  /* *addxf3_truncdf */
    case 261:  /* *addxf3_truncsf */
    case 252:  /* *nmuldf3 */
    case 244:  /* *muldf3_trunc */
    case 242:  /* *subdf3_trunc */
    case 240:  /* *adddf3_trunc */
    case 235:  /* *nmulsf3 */
    case 207:  /* *adddi3_plus1 */
    case 198:  /* *addsi3_plus1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 195:  /* *tbit_or_3 */
    case 194:  /* *tbit_or_2 */
    case 183:  /* *tbit_and_3 */
    case 182:  /* *tbit_and_2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 193:  /* *tbit_or_1 */
    case 192:  /* *tbit_or_0 */
    case 181:  /* *tbit_and_1 */
    case 180:  /* *tbit_and_0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 191:  /* *cmpdi_orcm_1 */
    case 187:  /* *cmpsi_orcm_1 */
    case 179:  /* *cmpdi_andnot_1 */
    case 175:  /* *cmpsi_andnot_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 190:  /* *cmpdi_orcm_0 */
    case 186:  /* *cmpsi_orcm_0 */
    case 178:  /* *cmpdi_andnot_0 */
    case 174:  /* *cmpsi_andnot_0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 189:  /* *cmpdi_or_1 */
    case 185:  /* *cmpsi_or_1 */
    case 177:  /* *cmpdi_and_1 */
    case 173:  /* *cmpsi_and_1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 188:  /* *cmpdi_or_0 */
    case 184:  /* *cmpsi_or_0 */
    case 176:  /* *cmpdi_and_0 */
    case 172:  /* *cmpsi_and_0 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 512:  /* fixuns_truncrfdi2_alts */
    case 511:  /* fix_truncrfdi2_alts */
    case 224:  /* negti2 */
    case 171:  /* one_cmplbi2 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 471:  /* fpack */
    case 468:  /* sminv2sf3 */
    case 467:  /* smaxv2sf3 */
    case 462:  /* mulv2sf3 */
    case 457:  /* *vecinit_v2si */
    case 435:  /* *cmpgt_v2si */
    case 434:  /* *cmpgt_v4hi */
    case 433:  /* *cmpgt_v8qi */
    case 432:  /* *cmpeq_v2si */
    case 431:  /* *cmpeq_v4hi */
    case 430:  /* *cmpeq_v8qi */
    case 429:  /* lshrv2si3 */
    case 428:  /* lshrv4hi3 */
    case 427:  /* ashrv2si3 */
    case 426:  /* ashrv4hi3 */
    case 425:  /* ashlv2si3 */
    case 424:  /* ashlv4hi3 */
    case 423:  /* *sminv4hi3 */
    case 422:  /* *uminv8qi3 */
    case 421:  /* *smaxv4hi3 */
    case 420:  /* *umaxv8qi3 */
    case 415:  /* mulv4hi3 */
    case 414:  /* *ussubv4hi3 */
    case 413:  /* *ussubv8qi3 */
    case 412:  /* *sssubv4hi3 */
    case 411:  /* *sssubv8qi3 */
    case 410:  /* subv2si3 */
    case 409:  /* subv4hi3 */
    case 408:  /* subv8qi3 */
    case 407:  /* *usaddv4hi3 */
    case 406:  /* *usaddv8qi3 */
    case 405:  /* *ssaddv4hi3 */
    case 404:  /* *ssaddv8qi3 */
    case 403:  /* addv2si3 */
    case 402:  /* addv4hi3 */
    case 401:  /* addv8qi3 */
    case 397:  /* xorv2si3 */
    case 396:  /* xorv4hi3 */
    case 395:  /* xorv8qi3 */
    case 394:  /* iorv2si3 */
    case 393:  /* iorv4hi3 */
    case 392:  /* iorv8qi3 */
    case 388:  /* andv2si3 */
    case 387:  /* andv4hi3 */
    case 386:  /* andv8qi3 */
    case 307:  /* xordi3 */
    case 306:  /* iordi3 */
    case 304:  /* anddi3 */
    case 301:  /* *rotlti3_internal */
    case 300:  /* *lshrti3_internal */
    case 299:  /* *ashrti3_internal */
    case 298:  /* *ashlti3_internal */
    case 297:  /* *rotldi3_internal */
    case 296:  /* *rotrdi3_internal */
    case 295:  /* lshrdi3 */
    case 294:  /* ashrdi3 */
    case 291:  /* ashldi3 */
    case 290:  /* *rotlsi3_internal */
    case 289:  /* *rotrsi3_internal */
    case 288:  /* *ashlsi3_internal */
    case 275:  /* smaxxf3 */
    case 274:  /* sminxf3 */
    case 266:  /* mulxf3 */
    case 263:  /* subxf3 */
    case 260:  /* addxf3 */
    case 251:  /* smaxdf3 */
    case 250:  /* smindf3 */
    case 243:  /* muldf3 */
    case 241:  /* subdf3 */
    case 239:  /* adddf3 */
    case 234:  /* smaxsf3 */
    case 233:  /* sminsf3 */
    case 227:  /* mulsf3 */
    case 226:  /* subsf3 */
    case 225:  /* addsf3 */
    case 211:  /* muldi3 */
    case 209:  /* subdi3 */
    case 206:  /* adddi3 */
    case 203:  /* mulsi3 */
    case 201:  /* subsi3 */
    case 197:  /* addsi3 */
    case 196:  /* mulhi3 */
    case 169:  /* iorbi3 */
    case 167:  /* andbi3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 166:  /* *mix4right_3op */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 1), 0), 0));
      break;

    case 165:  /* mix4right */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 164:  /* *mix4left */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 163:  /* shift_mix4left */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 292:  /* *shladd */
    case 204:  /* maddsi4 */
    case 200:  /* *addsi3_shladd */
    case 162:  /* *depz_internal */
    case 161:  /* *shladdp4_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 160:  /* *insv_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 0), 2));
      ro[3] = *(ro_loc[3] = &XEXP (pat, 1));
      break;

    case 470:  /* *fselect */
    case 463:  /* fmav2sf4 */
    case 279:  /* fmaxf4 */
    case 254:  /* fmadf4 */
    case 236:  /* fmasf4 */
    case 159:  /* extzv */
    case 158:  /* extv */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 125:  /* *add_tprel22 */
    case 124:  /* *add_tprel14 */
    case 123:  /* *load_ltoff_tprel */
    case 119:  /* *add_dtprel22 */
    case 118:  /* *add_dtprel14 */
    case 117:  /* *load_ltoff_dtprel */
    case 113:  /* *load_ltoff_dtpmod */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 391:  /* *andnotv2si */
    case 390:  /* *andnotv4hi */
    case 389:  /* *andnotv8qi */
    case 305:  /* *andnot */
    case 210:  /* *subdi3_minus1 */
    case 202:  /* *subsi3_minus1 */
    case 170:  /* *iorcmbi3 */
    case 168:  /* *andcmbi3 */
    case 111:  /* *load_symptr_low */
    case 110:  /* *load_symptr_high */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 377:  /* ip_value */
    case 352:  /* bsp_value */
    case 109:  /* *movdi_ret_addr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 510:  /* truncrfxf2 */
    case 509:  /* truncrfdf2 */
    case 508:  /* truncrfsf2 */
    case 507:  /* extendxfrf2 */
    case 506:  /* extenddfrf2 */
    case 505:  /* extendsfrf2 */
    case 460:  /* negv2sf2 */
    case 459:  /* absv2sf2 */
    case 454:  /* *mux2_brcst_hi */
    case 448:  /* mux1_brcst_qi */
    case 446:  /* *mux1_alt */
    case 445:  /* *mux1_shuf */
    case 444:  /* *mux1_mix */
    case 443:  /* *mux1_rev */
    case 400:  /* negv2si2 */
    case 399:  /* negv4hi2 */
    case 398:  /* negv8qi2 */
    case 385:  /* one_cmplv2si2 */
    case 384:  /* one_cmplv4hi2 */
    case 383:  /* one_cmplv8qi2 */
    case 322:  /* *seq_internal */
    case 321:  /* *sne_internal */
    case 308:  /* one_cmpldi2 */
    case 303:  /* one_cmplsi2 */
    case 270:  /* negxf2 */
    case 269:  /* absxf2 */
    case 246:  /* negdf2 */
    case 245:  /* absdf2 */
    case 229:  /* negsf2 */
    case 228:  /* abssf2 */
    case 218:  /* bswapdi2 */
    case 217:  /* popcountdi2 */
    case 216:  /* negdi2 */
    case 205:  /* negsi2 */
    case 157:  /* fixuns_truncrfdi2 */
    case 156:  /* fixuns_truncxfdi2 */
    case 155:  /* fixuns_truncdfdi2 */
    case 154:  /* fixuns_truncsfdi2 */
    case 153:  /* floatunsdirf2 */
    case 152:  /* floatunsdixf2 */
    case 151:  /* floatunsdidf2 */
    case 150:  /* floatunsdisf2 */
    case 149:  /* fix_truncrfdi2 */
    case 148:  /* fix_truncxfdi2 */
    case 147:  /* fix_truncdfdi2 */
    case 146:  /* fix_truncsfdi2 */
    case 145:  /* floatdixf2 */
    case 144:  /* floatdirf2 */
    case 143:  /* truncxfdf2 */
    case 142:  /* truncxfsf2 */
    case 141:  /* truncdfsf2 */
    case 140:  /* extenddfxf2 */
    case 139:  /* extendsfxf2 */
    case 138:  /* extendsfdf2 */
    case 137:  /* zero_extendsidi2 */
    case 136:  /* zero_extendhidi2 */
    case 135:  /* zero_extendqidi2 */
    case 134:  /* extendsidi2 */
    case 133:  /* extendhidi2 */
    case 132:  /* extendqidi2 */
    case 108:  /* *gprel64_offset */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 107:  /* load_gprel */
    case 106:  /* *load_fptr_internal1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 105:  /* speculation_check_ti */
    case 104:  /* speculation_check_xf */
    case 103:  /* speculation_check_df */
    case 102:  /* speculation_check_sf */
    case 101:  /* speculation_check_di */
    case 100:  /* speculation_check_si */
    case 99:  /* speculation_check_hi */
    case 98:  /* speculation_check_qi */
    case 97:  /* speculation_check_bi */
    case 96:  /* advanced_load_check_nc_ti */
    case 95:  /* advanced_load_check_nc_xf */
    case 94:  /* advanced_load_check_nc_df */
    case 93:  /* advanced_load_check_nc_sf */
    case 92:  /* advanced_load_check_nc_di */
    case 91:  /* advanced_load_check_nc_si */
    case 90:  /* advanced_load_check_nc_hi */
    case 89:  /* advanced_load_check_nc_qi */
    case 88:  /* advanced_load_check_nc_bi */
    case 87:  /* advanced_load_check_clr_ti */
    case 86:  /* advanced_load_check_clr_xf */
    case 85:  /* advanced_load_check_clr_df */
    case 84:  /* advanced_load_check_clr_sf */
    case 83:  /* advanced_load_check_clr_di */
    case 82:  /* advanced_load_check_clr_si */
    case 81:  /* advanced_load_check_clr_hi */
    case 80:  /* advanced_load_check_clr_qi */
    case 79:  /* advanced_load_check_clr_bi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 78:  /* zero_extendsidi2_nc */
    case 77:  /* zero_extendhidi2_nc */
    case 76:  /* zero_extendqidi2_nc */
    case 75:  /* zero_extendsidi2_clr */
    case 74:  /* zero_extendhidi2_clr */
    case 73:  /* zero_extendqidi2_clr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 0;
      break;

    case 72:  /* movti_nc */
    case 71:  /* movxf_nc */
    case 70:  /* movdf_nc */
    case 69:  /* movsf_nc */
    case 68:  /* movdi_nc */
    case 67:  /* movsi_nc */
    case 66:  /* movhi_nc */
    case 65:  /* movqi_nc */
    case 64:  /* movbi_nc */
    case 63:  /* movti_clr */
    case 62:  /* movxf_clr */
    case 61:  /* movdf_clr */
    case 60:  /* movsf_clr */
    case 59:  /* movdi_clr */
    case 58:  /* movsi_clr */
    case 57:  /* movhi_clr */
    case 56:  /* movqi_clr */
    case 55:  /* movbi_clr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0);
      recog_data.dup_num[0] = 0;
      recog_data.dup_loc[1] = &XEXP (XEXP (pat, 1), 2);
      recog_data.dup_num[1] = 0;
      break;

    case 54:  /* zero_extendsidi2_speculative_a */
    case 53:  /* zero_extendhidi2_speculative_a */
    case 52:  /* zero_extendqidi2_speculative_a */
    case 51:  /* zero_extendsidi2_speculative_advanced */
    case 50:  /* zero_extendhidi2_speculative_advanced */
    case 49:  /* zero_extendqidi2_speculative_advanced */
    case 30:  /* zero_extendsidi2_speculative */
    case 29:  /* zero_extendhidi2_speculative */
    case 28:  /* zero_extendqidi2_speculative */
    case 18:  /* zero_extendsidi2_advanced */
    case 17:  /* zero_extendhidi2_advanced */
    case 16:  /* zero_extendqidi2_advanced */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 513:  /* setf_exp_rf */
    case 479:  /* *vec_extractv2sf_1_be */
    case 478:  /* *vec_extractv2sf_1_le */
    case 477:  /* *vec_extractv2sf_0_be */
    case 476:  /* *vec_extractv2sf_0_le */
    case 374:  /* ptr_extend */
    case 351:  /* fr_restore */
    case 350:  /* fr_spill */
    case 219:  /* *getf_exp_xf */
    case 122:  /* *load_tprel_ie */
    case 121:  /* *load_tprel22 */
    case 120:  /* *load_tprel64 */
    case 116:  /* *load_dtprel_gd */
    case 115:  /* *load_dtprel22 */
    case 114:  /* *load_dtprel64 */
    case 112:  /* load_dtpmod */
    case 48:  /* movti_speculative_a */
    case 47:  /* movxf_speculative_a */
    case 46:  /* movdf_speculative_a */
    case 45:  /* movsf_speculative_a */
    case 44:  /* movdi_speculative_a */
    case 43:  /* movsi_speculative_a */
    case 42:  /* movhi_speculative_a */
    case 41:  /* movqi_speculative_a */
    case 40:  /* movbi_speculative_a */
    case 39:  /* movti_speculative_advanced */
    case 38:  /* movxf_speculative_advanced */
    case 37:  /* movdf_speculative_advanced */
    case 36:  /* movsf_speculative_advanced */
    case 35:  /* movdi_speculative_advanced */
    case 34:  /* movsi_speculative_advanced */
    case 33:  /* movhi_speculative_advanced */
    case 32:  /* movqi_speculative_advanced */
    case 31:  /* movbi_speculative_advanced */
    case 27:  /* movti_speculative */
    case 26:  /* movxf_speculative */
    case 25:  /* movdf_speculative */
    case 24:  /* movsf_speculative */
    case 23:  /* movdi_speculative */
    case 22:  /* movsi_speculative */
    case 21:  /* movhi_speculative */
    case 20:  /* movqi_speculative */
    case 19:  /* movbi_speculative */
    case 15:  /* movti_advanced */
    case 14:  /* movxf_advanced */
    case 13:  /* movdf_advanced */
    case 12:  /* movsf_advanced */
    case 11:  /* movdi_advanced */
    case 10:  /* movsi_advanced */
    case 9:  /* movhi_advanced */
    case 8:  /* movqi_advanced */
    case 7:  /* movbi_advanced */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 458:  /* *movv2sf_internal */
    case 382:  /* *movv2si_internal */
    case 381:  /* *movv4hi_internal */
    case 380:  /* *movv8qi_internal */
    case 131:  /* *movtf_internal */
    case 130:  /* *movrf_internal */
    case 129:  /* movxf_internal */
    case 128:  /* movdf_internal */
    case 127:  /* movsf_internal */
    case 126:  /* movti_internal */
    case 6:  /* movdi_internal */
    case 5:  /* movsi_internal */
    case 4:  /* movhi_internal */
    case 3:  /* movqi_internal */
    case 2:  /* movbi */
    case 1:  /* movcci */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    }
}
