/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 279:  /* *local_pic_storesidf */
    case 278:  /* *local_pic_storesisf */
    case 277:  /* *local_pic_storedidf */
    case 276:  /* *local_pic_storedisf */
    case 275:  /* *local_pic_storesidi */
    case 274:  /* *local_pic_storesisi */
    case 273:  /* *local_pic_storesihi */
    case 272:  /* *local_pic_storesiqi */
    case 271:  /* *local_pic_storedidi */
    case 270:  /* *local_pic_storedisi */
    case 269:  /* *local_pic_storedihi */
    case 268:  /* *local_pic_storediqi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 267:  /* *local_pic_loadusi */
    case 266:  /* *local_pic_loadusi */
    case 265:  /* *local_pic_loadusi */
    case 264:  /* *local_pic_loaduhi */
    case 263:  /* *local_pic_loaduhi */
    case 262:  /* *local_pic_loaduhi */
    case 261:  /* *local_pic_loaduqi */
    case 260:  /* *local_pic_loaduqi */
    case 259:  /* *local_pic_loaduqi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 258:  /* *local_pic_loaddf */
    case 257:  /* *local_pic_loadsf */
    case 256:  /* *local_pic_loaddf */
    case 255:  /* *local_pic_loadsf */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 250:  /* atomic_cas_value_strongdi */
    case 249:  /* atomic_cas_value_strongsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      ro[4] = *(ro_loc[4] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 2));
      ro[5] = *(ro_loc[5] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 3));
      ro[6] = *(ro_loc[6] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 248:  /* atomic_exchangedi */
    case 247:  /* atomic_exchangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 246:  /* atomic_fetch_anddi */
    case 245:  /* atomic_fetch_xordi */
    case 244:  /* atomic_fetch_ordi */
    case 243:  /* atomic_fetch_adddi */
    case 242:  /* atomic_fetch_andsi */
    case 241:  /* atomic_fetch_xorsi */
    case 240:  /* atomic_fetch_orsi */
    case 239:  /* atomic_fetch_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 238:  /* atomic_anddi */
    case 237:  /* atomic_xordi */
    case 236:  /* atomic_ordi */
    case 235:  /* atomic_adddi */
    case 234:  /* atomic_andsi */
    case 233:  /* atomic_xorsi */
    case 232:  /* atomic_orsi */
    case 231:  /* atomic_addsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0);
      recog_data.dup_num[0] = 0;
      break;

    case 228:  /* mem_thread_fence_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 227:  /* stack_tiedi */
    case 226:  /* stack_tiesi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 224:  /* riscv_frflags */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 225:  /* riscv_fsflags */
    case 222:  /* gpr_restore */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 221:  /* gpr_save */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      break;

    case 218:  /* call_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 217:  /* call_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 216:  /* sibcall_value_internal */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 215:  /* sibcall_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 214:  /* eh_set_lr_di */
    case 213:  /* eh_set_lr_si */
      ro[0] = *(ro_loc[0] = &XVECEXP (XVECEXP (pat, 0, 0), 0, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 223:  /* gpr_restore_return */
    case 212:  /* simple_return_internal */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 209:  /* tablejumpdi */
    case 208:  /* tablejumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 207:  /* indirect_jumpdi */
    case 206:  /* indirect_jumpsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 205:  /* jump */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 174:  /* fle_quietdfdi4 */
    case 173:  /* flt_quietdfdi4 */
    case 172:  /* fle_quietdfsi4 */
    case 171:  /* flt_quietdfsi4 */
    case 170:  /* fle_quietsfdi4 */
    case 169:  /* flt_quietsfdi4 */
    case 168:  /* fle_quietsfsi4 */
    case 167:  /* flt_quietsfsi4 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 166:  /* *cstoredfdi4 */
    case 165:  /* *cstoredfsi4 */
    case 164:  /* *cstoresfdi4 */
    case 163:  /* *cstoresfsi4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 162:  /* *branch_on_bit_rangedi */
    case 161:  /* *branch_on_bit_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 160:  /* *branch_on_bitdi */
    case 159:  /* *branch_on_bitsi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 2));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 158:  /* *branch_zerodi */
    case 157:  /* *branch_zerosi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 156:  /* *branch_orderdi */
    case 155:  /* *branch_ordersi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 220:  /* trap */
    case 219:  /* nop */
    case 211:  /* simple_return */
    case 210:  /* blockage */
    case 145:  /* fence_i */
    case 144:  /* fence */
      break;

    case 143:  /* *movdf_softfloat */
    case 142:  /* *movdf_hardfloat_rv64 */
    case 141:  /* *movdf_hardfloat_rv32 */
    case 140:  /* *movsf_softfloat */
    case 139:  /* *movsf_hardfloat */
    case 138:  /* *movqi_internal */
    case 133:  /* *movhi_internal */
    case 132:  /* *movsi_internal */
    case 131:  /* *movdi_64bit */
    case 130:  /* *movdi_32bit */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 121:  /* tls_add_tp_ledi */
    case 120:  /* tls_add_tp_lesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 125:  /* got_load_tls_iedi */
    case 124:  /* got_load_tls_iesi */
    case 123:  /* got_load_tls_gddi */
    case 122:  /* got_load_tls_gdsi */
    case 119:  /* got_loaddi */
    case 118:  /* got_loadsi */
    case 117:  /* lrounddfdi2 */
    case 116:  /* lrintdfdi2 */
    case 115:  /* lrounddfsi2 */
    case 114:  /* lrintdfsi2 */
    case 113:  /* lroundsfdi2 */
    case 112:  /* lrintsfdi2 */
    case 111:  /* lroundsfsi2 */
    case 110:  /* lrintsfsi2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 230:  /* atomic_storedi */
    case 229:  /* atomic_storesi */
    case 127:  /* auipcdi */
    case 126:  /* auipcsi */
    case 60:  /* copysigndf3 */
    case 59:  /* copysignsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 56:  /* *fnmadf4 */
    case 55:  /* *fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 54:  /* *fnmsdf4 */
    case 53:  /* *fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 52:  /* *fmsdf4 */
    case 51:  /* *fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 50:  /* *fmadf4 */
    case 49:  /* *fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 48:  /* fnmadf4 */
    case 47:  /* fnmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 46:  /* fnmsdf4 */
    case 45:  /* fnmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 44:  /* fmsdf4 */
    case 43:  /* fmssf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 42:  /* fmadf4 */
    case 41:  /* fmasf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 254:  /* *local_pic_loaddi */
    case 253:  /* *local_pic_loadsi */
    case 252:  /* *local_pic_loadhi */
    case 251:  /* *local_pic_loadqi */
    case 192:  /* *sgeu_didi */
    case 191:  /* *sge_didi */
    case 190:  /* *sgeu_disi */
    case 189:  /* *sge_disi */
    case 188:  /* *sgeu_sisi */
    case 187:  /* *sge_sisi */
    case 180:  /* *sne_zero_didi */
    case 179:  /* *sne_zero_disi */
    case 178:  /* *sne_zero_sisi */
    case 177:  /* *seq_zero_didi */
    case 176:  /* *seq_zero_disi */
    case 175:  /* *seq_zero_sisi */
    case 109:  /* floatunsdidf2 */
    case 108:  /* floatunssidf2 */
    case 107:  /* floatunsdisf2 */
    case 106:  /* floatunssisf2 */
    case 105:  /* floatdidf2 */
    case 104:  /* floatsidf2 */
    case 103:  /* floatdisf2 */
    case 102:  /* floatsisf2 */
    case 101:  /* fixuns_truncdfdi2 */
    case 100:  /* fixuns_truncdfsi2 */
    case 99:  /* fixuns_truncsfdi2 */
    case 98:  /* fixuns_truncsfsi2 */
    case 97:  /* fix_truncdfdi2 */
    case 96:  /* fix_truncdfsi2 */
    case 95:  /* fix_truncsfdi2 */
    case 94:  /* fix_truncsfsi2 */
    case 93:  /* extendsfdf2 */
    case 92:  /* extendhidi2 */
    case 91:  /* extendhisi2 */
    case 90:  /* extendhihi2 */
    case 89:  /* extendqidi2 */
    case 88:  /* extendqisi2 */
    case 87:  /* extendqihi2 */
    case 86:  /* extendsidi2 */
    case 85:  /* zero_extendqidi2 */
    case 84:  /* zero_extendqisi2 */
    case 83:  /* zero_extendqihi2 */
    case 82:  /* zero_extendhidi2 */
    case 81:  /* zero_extendhisi2 */
    case 80:  /* zero_extendsidi2 */
    case 79:  /* truncdfsf2 */
    case 78:  /* *one_cmplsi2_internal */
    case 77:  /* one_cmpldi2 */
    case 76:  /* one_cmplsi2 */
    case 62:  /* negdf2 */
    case 61:  /* negsf2 */
    case 58:  /* absdf2 */
    case 57:  /* abssf2 */
    case 40:  /* sqrtdf2 */
    case 39:  /* sqrtsf2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 24:  /* usmulsi3_highpart */
    case 23:  /* umulsi3_highpart */
    case 22:  /* mulsi3_highpart */
    case 21:  /* usmuldi3_highpart */
    case 20:  /* umuldi3_highpart */
    case 19:  /* muldi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 18:  /* *mulsi3_extended2 */
    case 12:  /* *subsi3_extended2 */
    case 6:  /* *addsi3_extended2 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 154:  /* *lshrsi3_extend */
    case 153:  /* *ashrsi3_extend */
    case 152:  /* *ashlsi3_extend */
    case 36:  /* *umodsi3_extended */
    case 35:  /* *modsi3_extended */
    case 34:  /* *udivsi3_extended */
    case 33:  /* *divsi3_extended */
    case 17:  /* *mulsi3_extended */
    case 11:  /* *subsi3_extended */
    case 5:  /* *addsi3_extended */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 204:  /* *sleu_didi */
    case 203:  /* *sle_didi */
    case 202:  /* *sleu_disi */
    case 201:  /* *sle_disi */
    case 200:  /* *sleu_sisi */
    case 199:  /* *sle_sisi */
    case 198:  /* *sltu_didi */
    case 197:  /* *slt_didi */
    case 196:  /* *sltu_disi */
    case 195:  /* *slt_disi */
    case 194:  /* *sltu_sisi */
    case 193:  /* *slt_sisi */
    case 186:  /* *sgtu_didi */
    case 185:  /* *sgt_didi */
    case 184:  /* *sgtu_disi */
    case 183:  /* *sgt_disi */
    case 182:  /* *sgtu_sisi */
    case 181:  /* *sgt_sisi */
    case 151:  /* lshrdi3 */
    case 150:  /* ashrdi3 */
    case 149:  /* ashldi3 */
    case 148:  /* lshrsi3 */
    case 147:  /* ashrsi3 */
    case 146:  /* ashlsi3 */
    case 137:  /* *xorsihi3 */
    case 136:  /* *xorhihi3 */
    case 135:  /* *addsihi3 */
    case 134:  /* *addhihi3 */
    case 129:  /* *lowdi */
    case 128:  /* *lowsi */
    case 75:  /* *xorsi3_internal */
    case 74:  /* *iorsi3_internal */
    case 73:  /* *andsi3_internal */
    case 72:  /* xordi3 */
    case 71:  /* iordi3 */
    case 70:  /* anddi3 */
    case 69:  /* xorsi3 */
    case 68:  /* iorsi3 */
    case 67:  /* andsi3 */
    case 66:  /* smaxdf3 */
    case 65:  /* smaxsf3 */
    case 64:  /* smindf3 */
    case 63:  /* sminsf3 */
    case 38:  /* divdf3 */
    case 37:  /* divsf3 */
    case 32:  /* umoddi3 */
    case 31:  /* moddi3 */
    case 30:  /* udivdi3 */
    case 29:  /* divdi3 */
    case 28:  /* umodsi3 */
    case 27:  /* modsi3 */
    case 26:  /* udivsi3 */
    case 25:  /* divsi3 */
    case 16:  /* muldi3 */
    case 15:  /* mulsi3 */
    case 14:  /* muldf3 */
    case 13:  /* mulsf3 */
    case 10:  /* subsi3 */
    case 9:  /* subdi3 */
    case 8:  /* subdf3 */
    case 7:  /* subsf3 */
    case 4:  /* adddi3 */
    case 3:  /* addsi3 */
    case 2:  /* adddf3 */
    case 1:  /* addsf3 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    }
}
